package com.haomostudio.SpringMVCProjectTemplate.service;

import com.haomostudio.SpringMVCProjectTemplate.domain.Country;

import java.util.List;

/**
 * Created by Hermione on 2016/1/7.
 */
public interface CountryService {

    int create(Country item);

    int delete(String id);

    int update(Country item);

    Country get(String id);

    /**
     * 获取列表
     * @param pageNo 整数,如1
     * @param pageSize 整数,如10
     * @param sortItem 格式为"id, name"
     * @param sortOrder 格式为"asc, desc"
     * @param filters JSON字符串,格式为
     *                {
     *                  table:
     *                  {
     *                    column1: {
     *                      like: '%abc%',
     *                      notLike: ''
     *                      between: [1, 10],
     *                      notBetween: [1, 10]
     *                      isNull: true,   // 只能为true
     *                      isNotNull: true,    // 只能为true
     *                      equalTo: "abc",
     *                      notEqualTo: "abc",
     *                      greaterThan: 10,
     *                      greaterThanOrEqualTo: 10,
     *                      lessThan: 10,
     *                      lessThanOrEqualTo: 10,
     *                      in: [],
     *                      notIn: []
     *                    }
     *                  }
     *                }
     * @return 列表
     */
    List<Country> getListWithPagingAndFilter(Integer pageNo, Integer pageSize,
                                             String sortItem, String sortOrder,
                                             String filters);
}
